﻿using System.Linq;
using Trinity.Helpers;
using Trinity.Technicals;
using Zeta.Bot.Profile.Composites;
using Zeta.TreeSharp;
using Zeta.XmlEngine;
using Logger = Trinity.Technicals.Logger;

namespace Trinity.ProfileTags
{
    [XmlElement("InfernoSelectAct")]
    public class InfernoSelectActTag : BaseComplexNodeTag
    {
        public InfernoSelectActTag() { }

        protected override Composite CreateBehavior()
        {
            return
            new Decorator(ret => !IsDone,
                new PrioritySelector(
                    GetNodes().Select(b => b.Behavior).ToArray()
                )
            );
        }

        public override bool GetConditionExec()
        {
            if (Inferno.RunStatus.Contains("InTown") && Inferno.AvailableToRun(Act))
            {
                Inferno.CurrentAct = Act;
                Logger.Log(TrinityLogLevel.Info, LogCategory.UserInformation, "[Inferno] Next run in Act{0}", Act);
                return true;
            }

            return false;
        }

        [XmlAttribute("act", true)]
        public int Act { get; set; }
    }
}
