﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;
using Trinity.Helpers;
using Zeta.Bot;

namespace Trinity
{
    public class InfernoUI
    {
        private static TabItem _tabItem;
        private static bool IsInstalled = false;

        private static Label labelRunInfos;
        // Key Count
        private static Label labelA1K;
        private static Label labelA2K;
        private static Label labelA3K;
        private static Label labelA4K;
        private static Label labelTK;
        // Key Dropped Count
        private static Label labelTKD;
        // Key/Hour
        private static Label labelTKH;
        // Key/Run
        private static Label labelA1KP;
        private static Label labelA2KP;
        private static Label labelA3KP;
        private static Label labelA4KP;
        private static Label labelTKP;
        // Key/Warden
        private static Label labelA1KW;
        private static Label labelA2KW;
        private static Label labelA3KW;
        private static Label labelA4KW;
        private static Label labelTKW;
        // Warden Found
        private static Label labelA1WF;
        private static Label labelA2WF;
        private static Label labelA3WF;
        private static Label labelA4WF;
        private static Label labelTWF;
        // Warden Vanquished
        private static Label labelA1WV;
        private static Label labelA2WV;
        private static Label labelA3WV;
        private static Label labelA4WV;
        private static Label labelTWV;
        // Warden Vanquished Count
        private static Label labelA1WVC;
        private static Label labelA2WVC;
        private static Label labelA3WVC;
        private static Label labelA4WVC;
        private static Label labelTWVC;
        // Warden Out Of Range
        private static Label labelA1WO;
        private static Label labelA2WO;
        private static Label labelA3WO;
        private static Label labelA4WO;
        private static Label labelTWO;
        // Run Count
        private static Label labelA1PC;
        private static Label labelA2PC;
        private static Label labelA3PC;
        private static Label labelA4PC;
        private static Label labelTPC;
        // Run Status
        public static Label labelA1PS;
        public static Label labelA2PS;
        public static Label labelA3PS;
        public static Label labelA4PS;
        public static Label labelTPS;

        public static void InstallTab()
        {
            if (IsInstalled)
                return;

            if (Application.Current.Dispatcher == null)
                return;

            Application.Current.Dispatcher.Invoke(
                () =>
                {
                    Rectangle Margin1 = new Rectangle()
                    {
                        Width = 4,
                        Height = 4,
                    };
                    Label labelKeyStats = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = ((40 * 5) + (4 * 2)),
                        Height = 25,
                        Margin = new Thickness(1),
                        HorizontalAlignment = HorizontalAlignment.Center,
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.Red,
                        Content = "INFERNAL KEYS",
                    };
                    Rectangle recKS = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    Rectangle Margin2 = new Rectangle()
                    {
                        Width = 4,
                        Height = 4,
                    };
                    Label labelWardenStats = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = ((40 * 3) + (2 * 2)),
                        Height = 25,
                        Margin = new Thickness(1),
                        HorizontalAlignment = HorizontalAlignment.Center,
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.Red,
                        Content = "WARDENS",
                    };
                    Rectangle recWS = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    Rectangle Margin3 = new Rectangle()
                    {
                        Width = 4,
                        Height = 4,
                    };
                    Label labelRun = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 120 + 40 + 2,
                        Height = 25,
                        Margin = new Thickness(1),
                        HorizontalAlignment = HorizontalAlignment.Center,
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.Red,
                        Content = "RUNS",
                    };
                    Rectangle recRS = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    //
                    // COL 0
                    //
                    Rectangle Margin0 = new Rectangle()
                    {
                        Width = 4,
                        Height = 4,
                    };
                    labelRunInfos = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 60,
                        Height = 25 + 25 + 2,
                        Margin = new Thickness(1),
                        FontSize = 9.0,
                        Content = "Run Timer :\n00:00:00\nGame Count:\n0",
                    };
                    Rectangle rec0 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    Label labelA1 = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 60,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Content = "ACT 1",
                    };
                    Label labelA2 = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 60,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Content = "ACT 2",
                    };
                    Label labelA3 = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 60,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Content = "ACT 3",
                    };
                    Label labelA4 = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 60,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Content = "ACT 4",
                    };
                    Label labelT = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 60,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.LawnGreen,
                        Content = "TOTAL",
                    };
                    //
                    // 	COL 1
                    //
                    Label labelKeysCount = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 25,
                        Margin = new Thickness(1),
                        FontSize = 8.0,
                        Content = "Keys\nCount",
                    };
                    Rectangle rec1 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    labelA1K = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelA2K = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelA3K = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelA4K = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelTK = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.LawnGreen,
                        Content = "0",
                    };
                    //
                    // 	COL 2
                    //
                    Label labelKeysDropCount = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 25,
                        Margin = new Thickness(1),
                        FontSize = 8.0,
                        Content = "Keys\nDropped",
                    };
                    Rectangle rec2 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    labelTKD = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = ((5 * 16) + (4 * 2)),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.LawnGreen,
                        Content = "0",
                    };
                    //
                    // COL 3
                    //
                    Label labelKeyPerHour = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 25,
                        Margin = new Thickness(1),
                        FontSize = 8.0,
                        Content = "Key/Hour",
                    };
                    Rectangle rec3 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    labelTKH = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = ((5 * 16) + (4 * 2)),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.LawnGreen,
                        Content = "0.00",
                    };
                    //
                    // COL 4
                    //
                    Label labelKeyPerRun = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 25,
                        Margin = new Thickness(1),
                        FontSize = 8.0,
                        Content = "Key/Run",
                    };
                    Rectangle rec4 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    labelA1KP = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = 16,
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA2KP = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = 16,
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA3KP = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = 16,
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA4KP = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = 16,
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelTKP = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = 16,
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.LawnGreen,
                        Content = "0%",
                    };
                    //
                    // COL 5
                    //
                    Label labelKeyPerWarden = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 25,
                        Margin = new Thickness(1),
                        FontSize = 8.0,
                        Content = "Key/Ward'",
                    };
                    Rectangle rec5 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    labelA1KW = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = 16,
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA2KW = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = 16,
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA3KW = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = 16,
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA4KW = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = 16,
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelTKW = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Margin = new Thickness(1),
                        Height = 16,
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.LawnGreen,
                        Content = "0%",
                    };
                    //
                    // COL 6
                    //
                    Label labelWardenFound = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 25,
                        Margin = new Thickness(1),
                        FontSize = 8.0,
                        Content = "Found\nBy Run",
                    };
                    Rectangle rec6 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    labelA1WF = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA2WF = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA3WF = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA4WF = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelTWF = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.LawnGreen,
                        Content = "0%",
                    };
                    //
                    // COL 7
                    //
                    Label labelWardenVanquished = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 25,
                        Margin = new Thickness(1),
                        FontSize = 8.0,
                        Content = "Defeated\nBy Found",
                    };
                    Rectangle rec7 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    labelA1WV = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA2WV = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA3WV = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA4WV = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelTWV = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.LawnGreen,
                        Content = "0%",
                    };
                    //
                    // COL 72
                    //
                    Label labelWardenVanquishedCount = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 25,
                        Margin = new Thickness(1),
                        FontSize = 8.0,
                        Content = "Defeated\nCount",
                    };
                    Rectangle rec72 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    labelA1WVC = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelA2WVC = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelA3WVC = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelA4WVC = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelTWVC = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.LawnGreen,
                        Content = "0",
                    };
                    //
                    // COL 8
                    //
                    Label labelWardenOutOfRange = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 25,
                        Margin = new Thickness(1),
                        FontSize = 8.0,
                        Content = "Out Range\nBy Found",
                    };
                    Rectangle rec8 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    labelA1WO = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA2WO = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA3WO = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelA4WO = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0%",
                    };
                    labelTWO = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.LawnGreen,
                        Content = "0%",
                    };
                    //
                    // COL 9
                    //
                    Label labelRunCount = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 25,
                        Margin = new Thickness(1),
                        FontSize = 8.0,
                        Content = "Run\nCount",
                    };
                    Rectangle rec9 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    labelA1PC = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelA2PC = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelA3PC = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelA4PC = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "0",
                    };
                    labelTPC = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 40,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        FontWeight = FontWeights.Bold,
                        Foreground = Brushes.LawnGreen,
                        Content = "0",
                    };
                    //
                    // COL 10
                    //
                    Label labelRunStatus = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 120,
                        Height = 25,
                        Margin = new Thickness(1),
                        FontSize = 8.0,
                        Content = "Run Status",
                    };
                    Rectangle rec10 = new Rectangle()
                    {
                        Width = 3,
                        Height = 3,
                    };
                    labelA1PS = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 120,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "Waiting for status",
                    };
                    labelA2PS = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 120,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "Waiting for status",
                    };
                    labelA3PS = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 120,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "Waiting for status",
                    };
                    labelA4PS = new Label()
                    {
                        HorizontalContentAlignment = HorizontalAlignment.Center,
                        VerticalContentAlignment = VerticalAlignment.Center,
                        Width = 120,
                        Height = 16,
                        Margin = new Thickness(1),
                        FontSize = 10.0,
                        Content = "Waiting for status",
                    };

                    // Stack Panel
                    StackPanel sp = new StackPanel()
                    {
                        Orientation = Orientation.Horizontal,
                        HorizontalAlignment = HorizontalAlignment.Left,
                    };
                    StackPanel recHp = new StackPanel()
                    {
                        Orientation = Orientation.Horizontal,
                        HorizontalAlignment = HorizontalAlignment.Left,
                    };
                    StackPanel recVp = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Left,
                    };
                    // Stats Panel VERTICAL
                    StackPanel kpV = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel wpV = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel ppV = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel btnpV = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    // Stats Panel HORIZONTAL
                    StackPanel kpH = new StackPanel()
                    {
                        Orientation = Orientation.Horizontal,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel wpH = new StackPanel()
                    {
                        Orientation = Orientation.Horizontal,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel ppH = new StackPanel()
                    {
                        Orientation = Orientation.Horizontal,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    // Colon Panel
                    StackPanel col0 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel col1 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel col2 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel col3 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel col4 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel col5 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel col6 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel col7 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel col72 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel col8 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel col9 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel col10 = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };
                    StackPanel spV = new StackPanel()
                    {
                        Orientation = Orientation.Vertical,
                        HorizontalAlignment = HorizontalAlignment.Left,
                    };
                    StackPanel spf = new StackPanel()
                    {
                        Orientation = Orientation.Horizontal,
                        HorizontalAlignment = HorizontalAlignment.Center,
                    };

                    // ACT //
                    col0.Children.Add(Margin0);
                    col0.Children.Add(labelRunInfos);
                    col0.Children.Add(rec0);
                    //
                    col0.Children.Add(labelA1);
                    col0.Children.Add(labelA2);
                    col0.Children.Add(labelA3);
                    col0.Children.Add(labelA4);
                    col0.Children.Add(labelT);
                    // Key stats //
                    col1.Children.Add(labelKeysCount);
                    col1.Children.Add(rec1);
                    col1.Children.Add(labelA1K);
                    col1.Children.Add(labelA2K);
                    col1.Children.Add(labelA3K);
                    col1.Children.Add(labelA4K);
                    col1.Children.Add(labelTK);
                    //
                    col2.Children.Add(labelKeysDropCount);
                    col2.Children.Add(rec2);
                    col2.Children.Add(labelTKD);
                    //
                    col3.Children.Add(labelKeyPerHour);
                    col3.Children.Add(rec3);
                    col3.Children.Add(labelTKH);
                    //
                    col4.Children.Add(labelKeyPerRun);
                    col4.Children.Add(rec4);
                    col4.Children.Add(labelA1KP);
                    col4.Children.Add(labelA2KP);
                    col4.Children.Add(labelA3KP);
                    col4.Children.Add(labelA4KP);
                    col4.Children.Add(labelTKP);
                    //
                    col5.Children.Add(labelKeyPerWarden);
                    col5.Children.Add(rec5);
                    col5.Children.Add(labelA1KW);
                    col5.Children.Add(labelA2KW);
                    col5.Children.Add(labelA3KW);
                    col5.Children.Add(labelA4KW);
                    col5.Children.Add(labelTKW);
                    //
                    kpH.Children.Add(col1);
                    kpH.Children.Add(col2);
                    kpH.Children.Add(col3);
                    kpH.Children.Add(col4);
                    kpH.Children.Add(col5);
                    //
                    kpV.Children.Add(Margin1);
                    kpV.Children.Add(labelKeyStats);
                    kpV.Children.Add(kpH);
                    // Warden Stats //
                    col6.Children.Add(labelWardenFound);
                    col6.Children.Add(rec6);
                    col6.Children.Add(labelA1WF);
                    col6.Children.Add(labelA2WF);
                    col6.Children.Add(labelA3WF);
                    col6.Children.Add(labelA4WF);
                    col6.Children.Add(labelTWF);
                    //
                    col72.Children.Add(labelWardenVanquishedCount);
                    col72.Children.Add(rec72);
                    col72.Children.Add(labelA1WVC);
                    col72.Children.Add(labelA2WVC);
                    col72.Children.Add(labelA3WVC);
                    col72.Children.Add(labelA4WVC);
                    col72.Children.Add(labelTWVC);
                    //
                    col7.Children.Add(labelWardenVanquished);
                    col7.Children.Add(rec7);
                    col7.Children.Add(labelA1WV);
                    col7.Children.Add(labelA2WV);
                    col7.Children.Add(labelA3WV);
                    col7.Children.Add(labelA4WV);
                    col7.Children.Add(labelTWV);
                    //
                    col8.Children.Add(labelWardenOutOfRange);
                    col8.Children.Add(rec8);
                    col8.Children.Add(labelA1WO);
                    col8.Children.Add(labelA2WO);
                    col8.Children.Add(labelA3WO);
                    col8.Children.Add(labelA4WO);
                    col8.Children.Add(labelTWO);
                    //
                    wpH.Children.Add(col6);
                    wpH.Children.Add(col72);
                    wpH.Children.Add(col7);
                    //
                    wpV.Children.Add(Margin2);
                    wpV.Children.Add(labelWardenStats);
                    wpV.Children.Add(wpH);
                    //
                    // Run Status //
                    col9.Children.Add(labelRunCount);
                    col9.Children.Add(rec9);
                    col9.Children.Add(labelA1PC);
                    col9.Children.Add(labelA2PC);
                    col9.Children.Add(labelA3PC);
                    col9.Children.Add(labelA4PC);
                    col9.Children.Add(labelTPC);
                    //
                    col10.Children.Add(labelRunStatus);
                    col10.Children.Add(rec10);
                    col10.Children.Add(labelA1PS);
                    col10.Children.Add(labelA2PS);
                    col10.Children.Add(labelA3PS);
                    col10.Children.Add(labelA4PS);
                    //
                    ppH.Children.Add(col9);
                    ppH.Children.Add(col10);
                    //
                    ppV.Children.Add(Margin3);
                    ppV.Children.Add(labelRun);
                    ppV.Children.Add(ppH);
                    //
                    sp.Children.Add(col0);
                    sp.Children.Add(recKS);
                    sp.Children.Add(kpV);
                    sp.Children.Add(recWS);
                    sp.Children.Add(wpV);
                    sp.Children.Add(recRS);
                    sp.Children.Add(ppV);
                    //
                    spV.Children.Add(sp);
                    //
                    spf.Children.Add(spV);

                    Window mainWindow = Application.Current.MainWindow;

                    _tabItem = new TabItem
                    {
                        Header = "Inferno",
                        Content = spf,
                    };

                    var tabs = mainWindow.FindName("tabControlMain") as TabControl;
                    if (tabs == null)
                        return;

                    tabs.Items.Add(_tabItem);
                    IsInstalled = true;

                    Inferno.RunTime = DateTime.Now;
                }
            );
        }

        internal static void RemoveTab()
        {
            if (Application.Current.Dispatcher == null)
                return;

            Application.Current.Dispatcher.Invoke(
                () =>
                {
                    Window mainWindow = Application.Current.MainWindow;
                    var tabs = mainWindow.FindName("tabControlMain") as TabControl;
                    if (tabs == null)
                        return;
                    tabs.Items.Remove(_tabItem);
                    IsInstalled = false;
                }
            );
        }

        public static void Refresh()
        {
            if (!IsInstalled)
                return;

            TimeSpan RunTime = DateTime.Now - Inferno.RunTime;
            double time = DateTime.Now.Subtract(Inferno.RunTime).TotalSeconds / 3600;
            double kh = Inferno.TotalDropCount.Sum() / time;
            string skh = kh.ToString("F2");

            SetContent(labelRunInfos, "Run Timer :\n" + RunTime.ToString(@"hh\:mm\:ss") + "\nGame Count:\n" + Inferno.GameCount);
            SetContent(labelTKH, skh);
            RefreshCount("All");
            InfernoUI.RefreshStatus();
        }

        public static bool RefreshCount(string counter)
        {
            if (!IsInstalled)
                return false;

            switch (counter)
            {
                case "Key":
                    RefreshKeyCount();
                    break;
                case "Found":
                    RefreshFoundCount();
                    break;
                case "Dead":
                    RefreshDeadCount();
                    break;
                case "Profile":
                    RefreshProfileCount();
                    break;
                case "All":
                    RefreshKeyCount();
                    RefreshFoundCount();
                    RefreshDeadCount();
                    RefreshProfileCount();
                    break;
                default:
                    break;
            }

            return true;
        }

        public static bool RefreshKeyCount()
        {
            if (!IsInstalled)
                return false;

            Inferno.RefreshKeyCount();

            // Key Count
            SetContent(labelA1K, Inferno.KeyCount[0] >= 0 ? Inferno.KeyCount[0].ToString() : "0");
            SetContent(labelA2K, Inferno.KeyCount[1] >= 0 ? Inferno.KeyCount[1].ToString() : "0");
            SetContent(labelA3K, Inferno.KeyCount[2] >= 0 ? Inferno.KeyCount[2].ToString() : "0");
            SetContent(labelA4K, Inferno.KeyCount[3] >= 0 ? Inferno.KeyCount[3].ToString() : "0");
            SetContent(labelTK, Inferno.KeyCount.Sum() >= 0 ? Inferno.KeyCount.Sum().ToString() : "0");

            // Key Dropped Count
            SetContent(labelTKD, Inferno.TotalDropCount.Sum().ToString());

            // Key per profile
            SetContent(labelA1KP, Inferno.RunByActCount != null && Inferno.RunByActCount[0] > 0 ? (((double)Inferno.TotalDropCount[0] / Inferno.RunByActCount[0]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA2KP, Inferno.RunByActCount != null && Inferno.RunByActCount[1] > 0 ? (((double)Inferno.TotalDropCount[1] / Inferno.RunByActCount[1]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA3KP, Inferno.RunByActCount != null && Inferno.RunByActCount[2] > 0 ? (((double)Inferno.TotalDropCount[2] / Inferno.RunByActCount[2]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA4KP, Inferno.RunByActCount != null &&  Inferno.RunByActCount[3] > 0 ? (((double)Inferno.TotalDropCount[3] / Inferno.RunByActCount[3]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelTKP, Inferno.RunByActCount != null && Inferno.RunByActCount.Sum() > 0 ? (((double)Inferno.TotalDropCount.Sum() / Inferno.RunByActCount.Sum()) * 100).ToString("F1") + "%" : "0%");

            // Key per warden
            SetContent(labelA1KW, Inferno.DefeatedWardensCount[0] > 0 ? (((double)Inferno.TotalDropCount[0] / Inferno.DefeatedWardensCount[0]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA2KW, Inferno.DefeatedWardensCount[1] > 0 ? (((double)Inferno.TotalDropCount[1] / Inferno.DefeatedWardensCount[1]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA3KW, Inferno.DefeatedWardensCount[2] > 0 ? (((double)Inferno.TotalDropCount[2] / Inferno.DefeatedWardensCount[2]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA4KW, Inferno.DefeatedWardensCount[3] > 0 ? (((double)Inferno.TotalDropCount[3] / Inferno.DefeatedWardensCount[3]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelTKW, Inferno.DefeatedWardensCount.Sum() > 0 ? (((double)Inferno.TotalDropCount.Sum() / Inferno.DefeatedWardensCount.Sum()) * 100).ToString("F1") + "%" : "0%");
            
            return true;
        }

        public static bool RefreshFoundCount()
        {
            if (!IsInstalled)
                return false;

            SetContent(labelA1WF, Inferno.RunByActCount != null && Inferno.RunByActCount[0] > 0 ? (((double)Inferno.FoundWardensCount[0] / Inferno.RunByActCount[0]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA2WF, Inferno.RunByActCount != null && Inferno.RunByActCount[1] > 0 ? (((double)Inferno.FoundWardensCount[1] / Inferno.RunByActCount[1]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA3WF, Inferno.RunByActCount != null && Inferno.RunByActCount[2] > 0 ? (((double)Inferno.FoundWardensCount[2] / Inferno.RunByActCount[2]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA4WF, Inferno.RunByActCount != null && Inferno.RunByActCount[3] > 0 ? (((double)Inferno.FoundWardensCount[3] / Inferno.RunByActCount[3]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelTWF, Inferno.RunByActCount != null && Inferno.RunByActCount.Sum() > 0 ? (((double)Inferno.FoundWardensCount.Sum() / Inferno.RunByActCount.Sum()) * 100).ToString("F1") + "%" : "0%");
            
            return true;
        }

        public static bool RefreshDeadCount()
        {
            if (!IsInstalled)
                return false;

            // Warden Defeated Count
            SetContent(labelA1WVC, Inferno.DefeatedWardensCount[0]);
            SetContent(labelA2WVC, Inferno.DefeatedWardensCount[1]);
            SetContent(labelA3WVC, Inferno.DefeatedWardensCount[2]);
            SetContent(labelA4WVC, Inferno.DefeatedWardensCount[3]);
            SetContent(labelTWVC, Inferno.DefeatedWardensCount.Sum());

            // Warden Defeated
            SetContent(labelA1WV, Inferno.FoundWardensCount[0] > 0 ? (((double)Inferno.DefeatedWardensCount[0] / Inferno.FoundWardensCount[0]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA2WV, Inferno.FoundWardensCount[1] > 0 ? (((double)Inferno.DefeatedWardensCount[1] / Inferno.FoundWardensCount[1]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA3WV, Inferno.FoundWardensCount[2] > 0 ? (((double)Inferno.DefeatedWardensCount[2] / Inferno.FoundWardensCount[2]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelA4WV, Inferno.FoundWardensCount[3] > 0 ? (((double)Inferno.DefeatedWardensCount[3] / Inferno.FoundWardensCount[3]) * 100).ToString("F1") + "%" : "0%");
            SetContent(labelTWV, Inferno.FoundWardensCount.Sum() > 0 ? (((double)Inferno.DefeatedWardensCount.Sum() / Inferno.FoundWardensCount.Sum()) * 100).ToString("F1") + "%" : "0%");
        
            return true;
        }

        public static bool RefreshProfileCount()
        {
            if (!IsInstalled)
                return false;

            SetContent(labelA1PC, Inferno.RunByActCount[0]);
            SetContent(labelA2PC, Inferno.RunByActCount[1]);
            SetContent(labelA3PC, Inferno.RunByActCount[2]);
            SetContent(labelA4PC, Inferno.RunByActCount[3]);
            SetContent(labelTPC, Inferno.RunByActCount.Sum());
        
            return true;
        }

        public static bool RefreshStatus()
        {
            if (!IsInstalled)
                return false;

            try
            {
                for (int i = 1; i <= 4; i++)
                {
                    if (Inferno.UsedAct.Contains(i))
                    {
                        ChangeProfileStatus(i, "Act Used");
                        ChangeStatusColor(i, "Red");
                    }
                    else if (Inferno.CurrentAct > 0 && Inferno.FoundWardensCount[Inferno.CurrentAct - 1] > Inferno.DefeatedWardensCount[Inferno.CurrentAct - 1] && Inferno.CurrentAct == i && Trinity.Player.IsInInfernoRun)
                    {
                        ChangeProfileStatus(i, "Killing Key Warden");
                        ChangeStatusColor(i, "Gold");
                    }
                    else if (Inferno.CurrentAct > 0 && Inferno.CurrentAct == i && Trinity.Player.IsInInfernoRun)
                    {
                        ChangeProfileStatus(i, "Looking for Key Warden");
                        ChangeStatusColor(i, "Gold");
                    }
                    else if (Inferno.AvailableToRun(i))
                    {
                        ChangeProfileStatus(i, "Available act");
                        ChangeStatusColor(i, "Green");
                    }
                    else
                    {
                        ChangeProfileStatus(i, "Not available act");
                        ChangeStatusColor(i, "Red");
                    }
                }
            }
            catch { }

            return true;
        }

        public static bool ChangeProfileStatus(int act, string content)
        {
            if (!IsInstalled)
                return false;

            switch (act)
            {
                case 1:
                    SetContent(labelA1PS, content);
                    break;
                case 2:
                    SetContent(labelA2PS, content);
                    break;
                case 3:
                    SetContent(labelA3PS, content);
                    break;
                case 4:
                    SetContent(labelA4PS, content);
                    break;
            }

            return true;
        }

        public static bool ChangeStatusColor(int act, string color)
        {
            if (!IsInstalled)
                return false;

            try
            {
                Application.Current.Dispatcher.BeginInvoke(
                new Action(
                    () =>
                    {
                        switch (act)
                        {
                            case 1:
                                switch (color)
                                {
                                    case "Gold":
                                        if (labelA1PS.Foreground != Brushes.Gold) 
                                            labelA1PS.Foreground = Brushes.Gold;
                                        break;
                                    case "Green":
                                        if (labelA1PS.Foreground != Brushes.LawnGreen) 
                                            labelA1PS.Foreground = Brushes.LawnGreen;
                                        break;
                                    case "Red":
                                        if (labelA1PS.Foreground != Brushes.Red) 
                                            labelA1PS.Foreground = Brushes.Red;
                                        break;
                                }
                                break;
                            case 2:
                                switch (color)
                                {
                                    case "Gold":
                                        if (labelA2PS.Foreground != Brushes.Gold) 
                                            labelA2PS.Foreground = Brushes.Gold;
                                        break;
                                    case "Green":
                                        if (labelA2PS.Foreground != Brushes.LawnGreen) 
                                            labelA2PS.Foreground = Brushes.LawnGreen;
                                        break;
                                    case "Red":
                                        if (labelA2PS.Foreground != Brushes.Red) 
                                            labelA2PS.Foreground = Brushes.Red;
                                        break;
                                }
                                break;
                            case 3:
                                switch (color)
                                {
                                    case "Gold":
                                        if (labelA3PS.Foreground != Brushes.Gold) 
                                            labelA3PS.Foreground = Brushes.Gold;
                                        break;
                                    case "Green":
                                        if (labelA3PS.Foreground != Brushes.LawnGreen) 
                                            labelA3PS.Foreground = Brushes.LawnGreen;
                                        break;
                                    case "Red":
                                        if (labelA3PS.Foreground != Brushes.Red) 
                                            labelA3PS.Foreground = Brushes.Red;
                                        break;
                                }
                                break;
                            case 4:
                                switch (color)
                                {
                                    case "Gold":
                                        if (labelA4PS.Foreground != Brushes.Gold) 
                                            labelA4PS.Foreground = Brushes.Gold;
                                        break;
                                    case "Green":
                                        if (labelA4PS.Foreground != Brushes.LawnGreen) 
                                            labelA4PS.Foreground = Brushes.LawnGreen;
                                        break;
                                    case "Red":
                                        if (labelA4PS.Foreground != Brushes.Red) 
                                            labelA4PS.Foreground = Brushes.Red;
                                        break;
                                }
                                break;
                        }
                    }
                    )
                );
            }
            catch { }

            return true;
        }

        public static bool SetContent(Label label, object value)
        {
            if (!IsInstalled)
                return false;

            try
            {

                Application.Current.Dispatcher.Invoke(() => 
                {
                    try
                    {
                        if (label.Content.ToString() != value.ToString())
                            label.Content = value;
                    }
                    catch
                    {
                    }
                });
            }
            catch { }

            return true;
        }

        public static bool SetContent(Button btn, object value)
        {
            if (!IsInstalled)
                return false;

            try
            {
                Application.Current.Dispatcher.Invoke(() => 
                {
                    try
                    {
                        if (btn.Content.ToString() != value.ToString()) 
                            btn.Content = value;
                    }
                    catch
                    {
                    }
                });
            }
            catch { }

            return true;
        }
    }
}